/*	ICMP Watcher	
	Coded by: Rohit Srivastava
 	On: Jul 18 23:11:49 1998 
*/

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <linux/ip.h>
#include <linux/icmp.h>
#include <netinet/in.h>


#define MAX_SIZE 65535

main( int nu_ar , char **po_ar )
{
	struct icmphdr *icmpHdr;
	struct iphdr *ipHdr;

	int sock,
	    read_bytes = 0,
	    len ,
	     nu = 0;

	unsigned char *buf = (unsigned char *)malloc(MAX_SIZE);

	struct sockaddr dest;
	struct in_addr inAddr;

	if( (sock = socket( AF_INET  , SOCK_RAW , 1 )) < 0 )
		{
		perror("Socket Not Initalized:");
		exit(1);
		}

	printf("<From>	<To>	<Code>	<Type>	<N'th Packet>\n");

	while( read( sock , buf , MAX_SIZE ) > 0 )
	{
	ipHdr = (struct iphdr *)buf;
	inAddr.s_addr = ipHdr->saddr;
	printf("%s\t" , inet_ntoa(  inAddr ) );
	inAddr.s_addr = ipHdr->daddr;
	printf("%s\t" , inet_ntoa(  inAddr ) );

	buf = buf + ntohs(ipHdr->tot_len);
	icmpHdr = (struct icmphdr *)buf ;

	printf( "%d\t" , ntohs(icmpHdr->type) );
	printf( "%d\t" , ntohs(icmpHdr->code) );
	printf( "%d\t" , nu++ );
	
	printf("\n");
	}
	close(sock);
}
