#include <netdb.h>
#include <stdio.h>
extern int h_errno;

/* Host to addr conversion routine */

int hostToaddr( char * host , u_long * val )
{
	long in_addr ;
	struct hostent *hp;

	if( (in_addr = inet_addr(host)) != -1 )
	{
	*val = in_addr;
	return 0;
	}
	else
	{
		while( (hp=gethostbyname(host)) == (struct hostent *)0 )
		{
			if( h_errno == HOST_NOT_FOUND )
			{	
			printf("Host %s not found!" , host );
			return -1;
			}
			if( h_errno = TRY_AGAIN )
			{
			printf("Trying to resolve again!");
			continue;
			}
			if( h_errno == NO_ADDRESS )
			{
			printf("Host %s not found!" , host );
			return -1;
			}
		}
		bcopy( (const void *)hp->h_addr , (void *)val , hp->h_length );
		return 0;
	}

}
